declare module 'react-native-ico-flags' {
    import { ReactElement } from 'react';
    import { SvgProps, AdditionalProps } from 'react-native-svg';

    type iconNames =
        | 'ethiopia'
        | 'oman'
        | 'tanzania'
        | 'slovenia'
        | 'puerto-rico'
        | 'mozambique'
        | 'iraq'
        | 'lebanon'
        | 'uganda'
        | 'nigeria'
        | 'italy'
        | 'malta'
        | 'tunisia'
        | 'nicaragua'
        | 'el-salvador'
        | 'zambia'
        | 'wales'
        | 'dominican-republic'
        | 'qatar'
        | 'namibia'
        | 'mauritius'
        | 'european-union'
        | 'luxembourg'
        | 'hawaii'
        | 'lithuania'
        | 'jamaica'
        | 'honduras'
        | 'myanmar'
        | 'kenya'
        | 'cyprus'
        | 'pakistan'
        | 'latvia'
        | 'japan'
        | 'kazakhstan'
        | 'serbia'
        | 'scotland'
        | 'north-korea'
        | 'uruguay'
        | 'syria'
        | 'guatemala'
        | 'iceland'
        | 'jordan'
        | 'monaco'
        | 'spain'
        | 'slovakia'
        | 'united-nations'
        | 'panama'
        | 'new-zealand'
        | 'ecuador'
        | 'romania'
        | 'chile'
        | 'finland'
        | 'hungary'
        | 'belgium'
        | 'south-korea'
        | 'malaysia'
        | 'venezuela'
        | 'norway'
        | 'saudi-arabia'
        | 'israel'
        | 'czech-republic'
        | 'colombia'
        | 'iran'
        | 'argentina'
        | 'ukraine'
        | 'germany'
        | 'hong-kong'
        | 'united-arab-emirates'
        | 'laos'
        | 'ireland'
        | 'greece'
        | 'denmark'
        | 'sweden'
        | 'peru'
        | 'south-africa'
        | 'philippines'
        | 'france'
        | 'indonesia'
        | 'egypt'
        | 'taiwan'
        | 'cook-islands'
        | 'cocos-island'
        | 'christmas-island'
        | 'ceuta'
        | 'american-samoa'
        | 'morocco'
        | 'anguilla'
        | 'corsica'
        | 'canary-islands'
        | 'comoros'
        | 'central-african-republic'
        | 'cayman-islands'
        | 'british-indian-ocean-territory'
        | 'bhutan'
        | 'chad'
        | 'cape-verde'
        | 'cabo-verde'
        | 'switzerland'
        | 'benin'
        | 'aruba'
        | 'balearic-islands'
        | 'andorra'
        | 'burundi'
        | 'antigua-and-barbuda'
        | 'aland-islands'
        | 'cameroon'
        | 'brunei'
        | 'poland'
        | 'bonaire'
        | 'belarus'
        | 'barbados'
        | 'british-virgin-islands'
        | 'bosnia-and-herzegovina'
        | 'bermuda'
        | 'belize'
        | 'bahrain'
        | 'albania'
        | 'burkina-faso'
        | 'turkey'
        | 'basque-country'
        | 'armenia'
        | 'afghanistan'
        | 'british-columbia'
        | 'angola'
        | 'azerbaijan'
        | 'algeria'
        | 'botswana'
        | 'bangladesh'
        | 'cuba'
        | 'australia'
        | 'costa-rica'
        | 'cambodia'
        | 'bolivia'
        | 'croatia'
        | 'bulgaria'
        | 'galapagos-islands'
        | 'martinique'
        | 'tonga'
        | 'st-lucia'
        | 'rapa-nui'
        | 'singapore'
        | 'palau'
        | 'niue'
        | 'macao'
        | 'fiji'
        | 'faroe-islands'
        | 'dominica'
        | 'vanuatu'
        | 'sierra-leone'
        | 'seychelles'
        | 'kosovo'
        | 'england'
        | 'united-states-of-america'
        | 'guinea'
        | 'orkney-islands'
        | 'turks-and-caicos'
        | 'transnistria'
        | 'tokelau'
        | 'gambia'
        | 'st-vincent-and-the-grenadines'
        | 'south-sudan'
        | 'somaliland'
        | 'solomon-islands'
        | 'vietnam'
        | 'sint-maarten'
        | 'sint-eustatius'
        | 'saint-kitts-and-nevis'
        | 'saba-island'
        | 'pitcairn-islands'
        | 'palestine'
        | 'ossetia'
        | 'northern-marianas-islands'
        | 'nauru'
        | 'portugal'
        | 'montserrat'
        | 'melilla'
        | 'mauritania'
        | 'kuwait'
        | 'guernsey'
        | 'guam'
        | 'grenada'
        | 'greenland'
        | 'thailand'
        | 'gibraltar'
        | 'gabon'
        | 'falkland-islands'
        | 'virgin-islands'
        | 'austria'
        | 'vatican-city'
        | 'tuvalu'
        | 'turkmenistan'
        | 'togo'
        | 'bahamas'
        | 'netherlands'
        | 'azores-islands'
        | 'suriname'
        | 'somalia'
        | 'sicily'
        | 'sardinia'
        | 'sao-tome-and-principe'
        | 'norfolk-island'
        | 'niger'
        | 'micronesia'
        | 'marshall-islands'
        | 'canada'
        | 'mali'
        | 'kyrgyzstan'
        | 'guinea-bissau'
        | 'eritrea'
        | 'djibouti'
        | 'curacao'
        | 'st-barts'
        | 'san-marino'
        | 'northern-cyprus'
        | 'liechtenstein'
        | 'india'
        | 'liberia'
        | 'yemen'
        | 'uzbekistan'
        | 'sudan'
        | 'sahrawi-arab-democratic-republic'
        | 'republic-of-macedonia'
        | 'otan'
        | 'libya'
        | 'east-timor'
        | 'tibet'
        | 'russia'
        | 'papua-new-guinea'
        | 'montenegro'
        | 'moldova'
        | 'maldives'
        | 'madeira'
        | 'french-polynesia'
        | 'trinidad-and-tobago'
        | 'tajikistan'
        | 'sri-lanka'
        | 'mexico'
        | 'republic-of-the-congo'
        | 'equatorial-guinea'
        | 'zimbabwe'
        | 'rwanda'
        | 'lesotho'
        | 'ivory-coast'
        | 'isle-of-man'
        | 'haiti'
        | 'samoa'
        | 'nepal'
        | 'brazil'
        | 'mongolia'
        | 'malawi'
        | 'madagascar'
        | 'jersey'
        | 'ghana'
        | 'georgia'
        | 'estonia'
        | 'democratic-republic-of-congo'
        | 'senegal'
        | 'paraguay'
        | 'china'
        | 'united-kingdom'
        | 'ET'
        | 'OM'
        | 'TZ'
        | 'SI'
        | 'PR'
        | 'MZ'
        | 'IQ'
        | 'LB'
        | 'UG'
        | 'NG'
        | 'IT'
        | 'MT'
        | 'TN'
        | 'NI'
        | 'SV'
        | 'ZM'
        | 'WA'
        | 'DO'
        | 'QA'
        | 'NA'
        | 'MU'
        | 'EU'
        | 'LU'
        | 'HI'
        | 'LT'
        | 'JM'
        | 'HN'
        | 'MM'
        | 'KE'
        | 'CY'
        | 'PK'
        | 'LV'
        | 'JP'
        | 'KZ'
        | 'RS'
        '| SCT'
        | 'KP'
        | 'UY'
        | 'SY'
        | 'GT'
        | 'IS'
        | 'JO'
        | 'MC'
        | 'ES'
        | 'SK'
        | 'UN'
        | 'PA'
        | 'NZ'
        | 'EC'
        | 'RO'
        | 'CL'
        | 'FI'
        | 'HU'
        | 'BE'
        | 'KR'
        | 'MY'
        | 'VE'
        | 'NO'
        | 'SA'
        | 'IL'
        | 'CZ'
        | 'CO'
        | 'IR'
        | 'AR'
        | 'UA'
        | 'DE'
        | 'HK'
        | 'AE'
        | 'LA'
        | 'IE'
        | 'GR'
        | 'DK'
        | 'SE'
        | 'PE'
        | 'ZA'
        | 'PH'
        | 'FR'
        | 'ID'
        | 'EG'
        | 'TW'
        | 'CK'
        | 'CC'
        | 'CX'
        | 'CE'
        | 'AS'
        | 'MA'
        | 'AI'
        | 'CS'
        | 'IC'
        | 'KM'
        | 'CF'
        | 'KY'
        | 'IO'
        | 'BT'
        | 'TD'
        | 'CV'
        | 'CH'
        | 'BJ'
        | 'AW'
        | 'AB'
        | 'IB'
        | 'AD'
        | 'BI'
        | 'AG'
        | 'AX'
        | 'CM'
        | 'BX'
        | 'PL'
        | 'BQ'
        | 'BY'
        | 'BB'
        | 'VG'
        | 'BA'
        | 'BM'
        | 'BZ'
        | 'BH'
        | 'AL'
        | 'BF'
        | 'TR'
        | 'BC'
        | 'AO'
        | 'AZ'
        | 'DZ'
        | 'BW'
        | 'BD'
        | 'CU'
        | 'AU'
        | 'CR'
        | 'KH'
        | 'BO'
        | 'HR'
        | 'BG'
        | 'GZ'
        | 'MQ'
        | 'TO'
        | 'LC'
        | 'RE'
        | 'SG'
        | 'PW'
        | 'NU'
        | 'MO'
        | 'FJ'
        | 'FO'
        | 'DM'
        | 'VU'
        | 'SL'
        | 'SC'
        | 'KV'
        | 'GB'
        | 'US'
        | 'GN'
        | 'OR'
        | 'TC'
        | 'NS'
        | 'TK'
        | 'GM'
        | 'VC'
        | 'SS'
        | 'SO'
        | 'SB'
        | 'VN'
        | 'SX'
        | 'SE'
        | 'KN'
        | 'SA'
        | 'PN'
        | 'PS'
        | 'OS'
        | 'MP'
        | 'NR'
        | 'PT'
        | 'MS'
        | 'ML'
        | 'MR'
        | 'KW'
        | 'GG'
        | 'GU'
        | 'GD'
        | 'GL'
        | 'TH'
        | 'GI'
        | 'GA'
        | 'FK'
        | 'VI'
        | 'AT'
        | 'VA'
        | 'TL'
        | 'TM'
        | 'TG'
        | 'BS'
        | 'NL'
        | 'AC'
        | 'SR'
        | 'SO'
        | 'SI'
        | 'SA'
        | 'ST'
        | 'NF'
        | 'NE'
        | 'FM'
        | 'MH'
        | 'CA'
        | 'ML'
        | 'KG'
        | 'GW'
        | 'ER'
        | 'DJ'
        | 'CW'
        | 'TB'
        | 'SM'
        | 'NC'
        | 'LI'
        | 'IN'
        | 'LR'
        | 'YE'
        | 'UZ'
        | 'SD'
        | 'EH'
        | 'MK'
        | 'OT'
        | 'LY'
        | 'TP'
        | 'TB'
        | 'RU'
        | 'PG'
        | 'ME'
        | 'MD'
        | 'MV'
        | 'MD'
        | 'PF'
        | 'TT'
        | 'TJ'
        | 'LK'
        | 'MX'
        | 'CG'
        | 'GQ'
        | 'ZW'
        | 'RW'
        | 'LS'
        | 'CI'
        | 'IM'
        | 'HT'
        | 'WS'
        | 'NP'
        | 'BR'
        | 'MN'
        | 'MW'
        | 'MG'
        | 'JE'
        | 'GH'
        | 'GE'
        | 'EE'
        | 'CD'
        | 'SN'
        | 'PY'
        | 'CN'
        | 'GB'
        | 'ETH'
        | 'OMN'
        | 'TZA'
        | 'SVN'
        | 'PRI'
        | 'MOZ'
        | 'IRQ'
        | 'LBN'
        | 'UGA'
        | 'NGA'
        | 'ITA'
        | 'MLT'
        | 'TUN'
        | 'NIC'
        | 'SLV'
        | 'ZMB'
        | 'WLS'
        | 'DOM'
        | 'QAT'
        | 'NAM'
        | 'MUS'
        | 'EUU'
        | 'LUX'
        | 'HWI'
        | 'LTU'
        | 'JAM'
        | 'HND'
        | 'MMR'
        | 'KEN'
        | 'CYP'
        | 'PAK'
        | 'LVA'
        | 'JPN'
        | 'KAZ'
        | 'SRB'
        | 'SCT'
        | 'PRK'
        | 'URY'
        | 'SYR'
        | 'GTM'
        | 'ISL'
        | 'JOR'
        | 'MCO'
        | 'ESP'
        | 'SVK'
        | 'UNO'
        | 'PAN'
        | 'NZL'
        | 'ECU'
        | 'ROU'
        | 'CHL'
        | 'FIN'
        | 'HUN'
        | 'BEL'
        | 'KOR'
        | 'MYS'
        | 'VEN'
        | 'NOR'
        | 'SAU'
        | 'ISR'
        | 'CZE'
        | 'COL'
        | 'IRN'
        | 'ARG'
        | 'UKR'
        | 'DEU'
        | 'HKG'
        | 'ARE'
        | 'LAO'
        | 'IRL'
        | 'GRC'
        | 'DNK'
        | 'SWE'
        | 'PER'
        | 'ZAF'
        | 'PHL'
        | 'FRA'
        | 'IDN'
        | 'EGY'
        | 'TWN'
        | 'COK'
        | 'CCK'
        | 'CXR'
        | 'XCE'
        | 'ASM'
        | 'MAR'
        | 'AIA'
        | 'XCO'
        | 'XIC'
        | 'COM'
        | 'CAF'
        | 'CYM'
        | 'IOT'
        | 'BTN'
        | 'TCD'
        | 'CPV'
        | 'CHE'
        | 'BEN'
        | 'ABW'
        | 'ABK'
        | 'XIB'
        | 'AND'
        | 'BDI'
        | 'ATG'
        | 'ALA'
        | 'CMR'
        | 'BRN'
        | 'POL'
        | 'BES'
        | 'BLR'
        | 'BRB'
        | 'VGB'
        | 'BIH'
        | 'BMU'
        | 'BLZ'
        | 'BHR'
        | 'ALB'
        | 'BFA'
        | 'TUR'
        | 'XBC'
        | 'AGO'
        | 'AZE'
        | 'DZA'
        | 'BWA'
        | 'BGD'
        | 'CUB'
        | 'AUS'
        | 'CRI'
        | 'KHM'
        | 'BOL'
        | 'HRV'
        | 'BGR'
        | 'XGZ'
        | 'MTQ'
        | 'TON'
        | 'LCA'
        | 'XRE'
        | 'SGP'
        | 'PLW'
        | 'NIU'
        | 'MAC'
        | 'FJI'
        | 'FRO'
        | 'DMA'
        | 'VUT'
        | 'SLE'
        | 'SYC'
        | 'RKS'
        | 'ENG'
        | 'USA'
        | 'GIN'
        | 'XOI'
        | 'TCA'
        | 'TNS'
        | 'TKL'
        | 'GMB'
        | 'VCT'
        | 'SSD'
        | 'SOM'
        | 'SLB'
        | 'VNM'
        | 'SXM'
        | 'XSE'
        | 'KNA'
        | 'XSA'
        | 'PCN'
        | 'PSE'
        | 'OSS'
        | 'MNP'
        | 'NRU'
        | 'PRT'
        | 'MSR'
        | 'XML'
        | 'MRT'
        | 'KWT'
        | 'GGY'
        | 'GUM'
        | 'GRD'
        | 'GRL'
        | 'THA'
        | 'GIB'
        | 'GAB'
        | 'FLK'
        | 'VIR'
        | 'AUT'
        | 'VAT'
        | 'TUV'
        | 'TKM'
        | 'TGO'
        | 'BHS'
        | 'NLD'
        | 'XAC'
        | 'SUR'
        | 'SOM'
        | 'SIC'
        | 'SAR'
        | 'STP'
        | 'NFK'
        | 'NER'
        | 'FSM'
        | 'MHL'
        | 'CAN'
        | 'MLI'
        | 'KGZ'
        | 'GNB'
        | 'ERI'
        | 'DJI'
        | 'CUW'
        | 'BLM'
        | 'SMR'
        | 'NCY'
        | 'LIE'
        | 'IND'
        | 'LBR'
        | 'YEM'
        | 'UZB'
        | 'SDN'
        | 'ESH'
        | 'MKD'
        | 'OTAN'
        | 'LBY'
        | 'TLS'
        | 'TIB'
        | 'RUS'
        | 'PNG'
        | 'MNE'
        | 'MDA'
        | 'MDV'
        | 'MAD'
        | 'PYF'
        | 'TTO'
        | 'TJK'
        | 'LKA'
        | 'MEX'
        | 'COG'
        | 'GNQ'
        | 'ZWE'
        | 'RWA'
        | 'LSO'
        | 'CIV'
        | 'IMN'
        | 'HTI'
        | 'WSM'
        | 'NPL'
        | 'BRA'
        | 'MNG'
        | 'MWI'
        | 'MDG'
        | 'JEY'
        | 'GHA'
        | 'GEO'
        | 'EST'
        | 'COD'
        | 'SEN'
        | 'PRY'
        | 'CHN'
        | 'GBR'
        | '251'
        | '968'
        | '255'
        | '386'
        | '1787'
        | '258'
        | '964'
        | '961'
        | '256'
        | '234'
        | '39'
        | '356'
        | '216'
        | '505'
        | '503'
        | '260'
        | '441978'
        | '1809'
        | '974'
        | '264'
        | '230'
        | '388'
        | '352'
        | '1808'
        | '370'
        | '1876'
        | '504'
        | '95'
        | '254'
        | '357'
        | '92'
        | '371'
        | '81'
        | '7'
        | '381'
        | '44131'
        | '850'
        | '598'
        | '963'
        | '502'
        | '354'
        | '962'
        | '377'
        | '34'
        | '421'
        | '1212'
        | '507'
        | '64'
        | '593'
        | '40'
        | '56'
        | '358'
        | '36'
        | '32'
        | '82'
        | '60'
        | '58'
        | '47'
        | '966'
        | '972'
        | '420'
        | '57'
        | '98'
        | '54'
        | '380'
        | '49'
        | '852'
        | '971'
        | '856'
        | '353'
        | '30'
        | '45'
        | '46'
        | '51'
        | '27'
        | '63'
        | '33'
        | '62'
        | '20'
        | '886'
        | '682'
        | '61'
        | '61'
        | '34'
        | '1684'
        | '212'
        | '1264'
        | '33'
        | '34'
        | '269'
        | '236'
        | '1345'
        | '246'
        | '975'
        | '235'
        | '238'
        | '41'
        | '229'
        | '297'
        | '7840'
        | '34'
        | '376'
        | '257'
        | '1268'
        | '35818'
        | '237'
        | '673'
        | '48'
        | '599'
        | '375'
        | '1246'
        | '1284'
        | '387'
        | '1441'
        | '501'
        | '973'
        | '355'
        | '226'
        | '90'
        | '1604'
        | '244'
        | '994'
        | '213'
        | '267'
        | '880'
        | '53'
        | '61'
        | '506'
        | '855'
        | '591'
        | '385'
        | '359'
        | '5935'
        | '596'
        | '676'
        | '1758'
        | '56'
        | '65'
        | '680'
        | '683'
        | '853'
        | '679'
        | '298'
        | '1767'
        | '678'
        | '232'
        | '248'
        | '383'
        | '44'
        | '1'
        | '224'
        | '441857'
        | '1649'
        | '373'
        | '690'
        | '220'
        | '1784'
        | '211'
        | '252'
        | '677'
        | '84'
        | '1721'
        | '5993'
        | '1869'
        | '5994'
        | '649'
        | '970'
        | '7840'
        | '1670'
        | '674'
        | '351'
        | '1664'
        | '34'
        | '222'
        | '965'
        | '441481'
        | '1671'
        | '1473'
        | '299'
        | '66'
        | '350'
        | '241'
        | '500'
        | '1340'
        | '43'
        | '379'
        | '688'
        | '993'
        | '228'
        | '1242'
        | '31'
        | '351292'
        | '597'
        | '252'
        | '3991'
        | '3970'
        | '239'
        | '672'
        | '227'
        | '691'
        | '692'
        | '1'
        | '223'
        | '996'
        | '245'
        | '291'
        | '253'
        | '5999'
        | '590'
        | '378'
        | '357392'
        | '423'
        | '91'
        | '231'
        | '967'
        | '998'
        | '249'
        | '212'
        | '389'
        | '329'
        | '218'
        | '670'
        | '8628'
        | '7'
        | '675'
        | '382'
        | '373'
        | '960'
        | '351291'
        | '689'
        | '1868'
        | '992'
        | '94'
        | '52'
        | '242'
        | '240'
        | '263'
        | '250'
        | '266'
        | '225'
        | '441624'
        | '509'
        | '685'
        | '977'
        | '55'
        | '976'
        | '265'
        | '261'
        | '441534'
        | '233'
        | '995'
        | '372'
        | '243'
        | '221'
        | '595'
        | '86'
        | '44';

    type iconColors = '#0052B4' |
      '#2E52B2' |
      '#333333' |
      '#338AF3' |
      '#496E2D' |
      '#4A1F63' |
      '#6DA544' |
      '#751A46' |
      '#786145' |
      '#818085' |
      '#91DC5A' |
      '#A2001D' |
      '#ACABB1' |
      '#BDBCC1' |
      '#D80027' |
      '#DEDDE0' |
      '#F0F0F0' |
      '#F3F3F3' |
      '#FCFCFC' |
      '#FF9811' |
      '#FFDA44' |
      '#FFEACF' |
      '#FFFFFF';

    type backgroundType = 'circle' | 'rect' | 'button';

    type colorsType = Record<iconColors, string>;

    type positionType = 'top' | 'bottom' | 'right' | 'left' |
      'top_right' | 'top_left' | 'bottom_right' | 'bottom_left';

    type backgroundTypeObj = {
      type?: backgroundType;
      color?: string;
      radius?: number;
      borderRadius?: number;
    };

    type badgeTypeObj = {
      value?: number | string;
      fontSize?: string;
      position?: positionType;
      color?: string;
      colors: colorsType;
      backgroundColor?: string;
      radius?: number;
    };

    interface IconProps {
      name: iconNames;
      width?: number;
      height?: number;
      color?: string;
      colors?: colorsType;
      stroke?: number;
      background?: backgroundType | backgroundTypeObj;
      badge?: number | string | badgeTypeObj;
    }

    const Icon: (props: IconProps & SvgProps & AdditionalProps) => ReactElement;

    export { iconNames };
    export default Icon;
}
